/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 * 
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 */

#ifndef _FVKBD_KEYBOARD_H
#define _FVKBD_KEYBOARD_H


#include "fvkbd-base.h"

G_BEGIN_DECLS

typedef struct _FvkbdKeyboard FvkbdKeyboard;
typedef struct _FvkbdKeyboardPrivate FvkbdKeyboardPrivate;
typedef struct _FvkbdKeyboardClass FvkbdKeyboardClass;

#define FVKBD_TYPE_KEYBOARD			(fvkbd_keyboard_get_type())
#define FVKBD_KEYBOARD(obj)			(G_TYPE_CHECK_INSTANCE_CAST((obj), FVKBD_TYPE_KEYBOARD, FvkbdKeyboard))
#define FVKBD_KEYBOARD_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST((klass), FVKBD_TYPE_KEYBOARD, FvkbdKeyboardClass))
#define FVKBD_IS_KEYBOARD(obj)		(G_TYPE_CHECK_INSTANCE_TYPE((obj), FVKBD_TYPE_KEYBOARD))
#define FVKBD_IS_KEYBOARD_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), FVKBD_TYPE_KEYBOARD))
#define FVKBD_KEYBOARD_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), FVKBD_TYPE_KEYBOARD, FvkbdKeyboardClass))

struct _FvkbdKeyboard {
	FvkbdUnit parent;
	FvkbdKeyboardPrivate *priv;
};

struct _FvkbdKeyboardClass {
	FvkbdUnitClass parent;
};

GType fvkbd_keyboard_get_type (void);

extern gboolean fvkbd_keyboard_build_ui (FvkbdUnit *unit, gpointer *widget);
gboolean fvkbd_keyboard_resize_ui (FvkbdUnit *unit, gfloat x_ratio, gfloat y_ratio);
extern gboolean fvkbd_keyboard_destroy_ui (FvkbdUnit *unit);

GSList *fvkbd_keyboard_get_panels (FvkbdKeyboard *self);
gint fvkbd_keyboard_get_current_mode (void);
gboolean fvkbd_in_temp_mode(void);
gint fvkbd_keyboard_change_mode (gint id, gboolean lock);
gint fvkbd_keyboard_resume_default_mode (void);
FakeKey *fvkbd_keyboard_get_fakekey (void);
gchar *fvkbd_keyboard_get_font_family (KbdFontType type);
gchar *fvkbd_keyboard_get_font_weight (KbdFontType type);
gint fvkbd_keyboard_get_font_size (KbdFontType type);

FvkbdUnit *fvkbd_keyboard_new (void);

G_END_DECLS

#endif //_FVKBD_KEYBOARD_H